]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
purge-packages: use git status --porcelain instead of --short
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
10d92f71 1#!/bin/ksh
44058243 2#
dece74ed
AM
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
cd445739 6# -----------
cd445739 7# Exit codes:
2a5f078d 8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
67963237 20# 110 - Functions not yet implemented
cd445739 21
f8e50be5 22# Notes (todo/bugs):
f8e50be5
ER
23# - when Icon: field is present, -5 and -a5 doesn't work
24# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
19aa2571 25# - does not respect NoSource: X, and tries to cvs up such files [ example: VirtualBox-bin.spec and its Source0 ]
f8e50be5
ER
26# TODO:
27# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
1ffcdaff
ER
28# - funny bug, if source-md5 is set then builder will download from distfiles even if there is no url present:
29# Source10: forwardfix.pl
30# # Source10-md5: 8bf85f7368933a4e0cb4f875bac28733
6ca6f876
ZU
31# - builder --help:
32# basename: missing operand
33# Try `basename --help' for more information.
34# -- and the normal usage info --
35
9d99a240
ER
36PROGRAM=${0##*/}
37APPDIR=$(d=$0; [ -L "$d" ] && d=$(readlink -f "$d"); dirname "$d")
cd112f74 38RCSID='$Id: builder,v 1.645 2011/02/13 17:54:10 glen Exp $' r=${RCSID#* * } rev=${r%% *}
b0f031e7 39VERSION="v0.35/$rev"
d43959a2 40VERSIONSTRING="\
b71f5024 41Build package utility from PLD Linux Packages repository
32131a0e 42$VERSION (C) 1999-2012 Free Penguins".
d43959a2 43
670b1ed4 44CLEAN_PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 45
b7cc0c94
ER
46# required rpm-build-macros
47RPM_MACROS_VER=1.534
48
cd445739 49COMMAND="build"
64ea5308 50TARGET=""
cd445739 51
bde1c404 52SPECFILE=""
d287305c 53BE_VERBOSE=""
4003ad8c 54QUIET=""
cd445739
AM
55CLEAN=""
56DEBUG=""
57NOURLS=""
cd445739
AM
58NOCVSSPEC=""
59NODIST=""
47761337 60NOINIT=""
bc10f694 61PREFMIRRORS=""
cd445739 62UPDATE=""
cd445739
AM
63ADD5=""
64NO5=""
65ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
cd445739 66
6c1b2e7d
PZ
67# use rpm 4.4.6+ digest format instead of comments if non-zero
68USEDIGEST=
69
e3aa6f5e
ER
70# user agent when fetching files
71USER_AGENT="PLD/Builder($VERSION)"
72
cd445739
AM
73# It can be used i.e. in log file naming.
74# See LOGFILE example.
75DATE=`date +%Y-%m-%d_%H-%M-%S`
76
7534a77d
ER
77# target arch, can also be used for log file naming
78TARGET=$(rpm -E %{_target})
79
cd445739
AM
80# Example: LOGFILE='../log.$PACKAGE_NAME'
81# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
d280fd97 82# Example: LOGFILE='$PACKAGE_NAME/$PACKAGE_NAME.$DATE.log'
f5687002 83# Example: LOGFILE='$PACKAGE_NAME.$DATE.log'
cd445739
AM
84# Yes, you can use variable name! Note _single_ quotes!
85LOGFILE=''
86
87LOGDIR=""
88LOGDIROK=""
89LOGDIRFAIL=""
90LASTLOG_FILE=""
91
92CHMOD="no"
1da227e8 93CHMOD_MODE="0644"
cd445739 94RPMOPTS=""
d1c5a9a7 95RPMBUILDOPTS=""
cd445739
AM
96BCOND=""
97GROUP_BCONDS="no"
ccffa567
ER
98
99# create symlinks for tools in PACKAGE_DIR, see get_spec()
2dd0af86 100SYMLINK_TOOLS="no"
d287305c 101
102PATCHES=""
103SOURCES=""
cd445739 104ICONS=""
d287305c 105PACKAGE_RELEASE=""
106PACKAGE_VERSION=""
107PACKAGE_NAME=""
14bead22 108ASSUMED_NAME=""
fd71d65c 109PROTOCOL="http"
2060f498
AM
110
111# use lftp by default when available
f4bac425 112USE_LFTP=
2060f498 113lftp --version > /dev/null 2>&1 && USE_LFTP=yes
d4c8d3a9 114PARALLEL_DOWNLOADS=10
2060f498 115
cd445739 116WGET_RETRIES=${MAX_WGET_RETRIES:-0}
cd445739 117
939f2c12 118CVS_FORCE=""
f123bcb5 119CVSIGNORE_DF="yes"
cd445739 120CVSTAG=""
7446994b
KK
121GIT_SERVER="git://git.pld-linux.org"
122GIT_PUSH="git@git.pld-linux.org"
76636346 123PACKAGES_DIR="packages"
a8f917c2 124HEAD_DETACHED=""
3189511a 125DEPTH=""
3f79cb18 126ALL_BRANCHES=""
608c01a7 127REMOTE_PLD="origin"
406b9ecf 128NEW_REPO=""
939f2c12 129
cd445739
AM
130RES_FILE=""
131
cd445739 132DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 133ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 134
36d03934 135DEF_NICE_LEVEL=19
86aafdbe 136SCHEDTOOL="auto"
cd445739
AM
137
138FAIL_IF_NO_SOURCES="yes"
139
18e5347d
ER
140# let get_files skip over files which are present to get those damn files fetched
141SKIP_EXISTING_FILES="no"
142
975d7b23 143TRY_UPGRADE=""
257af81b
ER
144# should the specfile be restored if upgrade failed?
145REVERT_BROKEN_UPGRADE="yes"
146
90baf90b
ER
147if rpm --specsrpm 2>/dev/null; then
148 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
ce40491a 149 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
90baf90b
ER
150else
151 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
152 if [ -x /usr/bin/rpm-getdeps ]; then
153 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
154 else
155 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
156 fi
ab4a2b6e
ER
157fi
158
8a390970 159UPDATE_POLDEK_INDEXES_OPTS=""
90baf90b 160
cd445739
AM
161# Here we load saved user environment used to
162# predefine options set above, or passed to builder
163# in command line.
164# This one reads global system environment settings:
165if [ -f ~/etc/builderrc ]; then
166 . ~/etc/builderrc
167fi
168# And this one cascades settings using user personal
169# builder settings.
170# Example of ~/.builderrc:
171#
172#UPDATE_POLDEK_INDEXES="yes"
8a390970 173#UPDATE_POLDEK_INDEXES_OPTS="--mo=nodiff"
cd445739
AM
174#FETCH_BUILD_REQUIRES="yes"
175#REMOVE_BUILD_REQUIRES="force"
176#GROUP_BCONDS="yes"
177#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 178#TITLECHANGE=no
cd445739 179#
a83e5405 180SU_SUDO=""
cd445739
AM
181if [ -n "$HOME_ETC" ]; then
182 USER_CFG="$HOME_ETC/.builderrc"
20117088 183 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
cd445739
AM
184else
185 USER_CFG=~/.builderrc
20117088 186 BUILDER_MACROS=~/.builder-rpmmacros
cd445739
AM
187fi
188
189[ -f "$USER_CFG" ] && . "$USER_CFG"
190
86aafdbe
ER
191if [ "$SCHEDTOOL" = "auto" ]; then
192 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
193 SCHEDTOOL="schedtool -B -e"
194 else
195 SCHEDTOOL="no"
196 fi
197fi
198
ca2e6c31 199if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
200 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
201 GETURI2="$GETURI"
202 OUTFILEOPT="-O"
ca2e6c31 203elif [ -n "$USE_AXEL" ]; then
cede92b3 204 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
205 GETURI2="$GETURI"
206 OUTFILEOPT="-o"
9639be96 207elif [ -n "$USE_LFTP" ]; then
9639be96
AM
208 GETURI=download_lftp
209 GETURI2=$GETURI
210 OUTFILEOPT=""
ca2e6c31 211else
5700ee32
ER
212 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
213 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
214 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
e3aa6f5e 215 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
6f9a5d76 216
7e365483
KK
217 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
218 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
219 OUTFILEOPT="-O"
2bc5451f 220fi
11468b23 221
11468b23
AM
222GETLOCAL="cp -a"
223
15e34b63 224if rpm --version 2>&1 | grep -q '4.0.[0-2]'; then
11468b23
AM
225 RPM="rpm"
226 RPMBUILD="rpm"
227else
228 RPM="rpm"
229 RPMBUILD="rpmbuild"
230fi
231
c86939e2 232#
233# sanity checks
234#
235if [ -d $HOME/rpm/SOURCES ]; then
236 echo "ERROR: ~/rpm/{SPECS,SOURCES} structure is obsolete" >&2
237 echo "ERROR: get rid of your ~/rpm/SOURCES" >&2
238 exit 1
239fi
240
a8c9a155 241POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
a83e5405 242POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 243
f6711e2a 244run_poldek() {
390d081d 245 RES_FILE=$(tempfile)
cd445739
AM
246 if [ -n "$LOGFILE" ]; then
247 LOG=`eval echo $LOGFILE`
248 if [ -n "$LASTLOG_FILE" ]; then
249 echo "LASTLOG=$LOG" > $LASTLOG_FILE
250 fi
86aafdbe 251 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
252 return $exit_pldk
253 else
86aafdbe 254 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
255 return `cat ${RES_FILE}`
256 rm -rf ${RES_FILE}
257 fi
258}
259
cd445739
AM
260#---------------------------------------------
261# functions
da946cd6 262
f4bac425 263download_lftp() {
6928bb29 264 local outfile=$1 url=$2 retval tmpfile
f4bac425
ER
265 # TODO: use mktemp
266 tmpfile=$outfile.tmp
4d1fc6ce
AM
267 lftp -c "
268 $([ "$DEBUG" = "yes" ] && echo "debug 5;")
78ff632e 269 set ssl:verify-certificate no;
4d1fc6ce
AM
270 set net:max-retries $WGET_RETRIES;
271 set http:user-agent \"$USER_AGENT\";
d4c8d3a9 272 pget -n $PARALLEL_DOWNLOADS -c \"$url\" -o \"$tmpfile\"
4d1fc6ce 273 "
f4bac425
ER
274
275 retval=$?
276 if [ $retval -eq 0 ]; then
277 mv -f "$tmpfile" "$outfile"
278 else
279 rm -f "$tmpfile"
280 fi
281 return $retval
282}
283
f6711e2a 284usage() {
cd445739 285 if [ -n "$DEBUG" ]; then set -xv; fi
647fead0
ER
286# NOTE:
287# to make this output parseable by bash-completion _parse_help()
288# if the line contains short and long option, it will take only the long option
289# but if you want both being completed, put the short option to separate line
cd445739 290 echo "\
3f79cb18 291Usage: builder [--all-branches] [-D|--debug] [-V|--version] [--short-version] [-a|--add_cvs] [-b|-ba|--build]
6594293d 292[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
0c8e5e9d 293[{-cf|--cvs-force}] [{-B|--branch} <branch>] [--depth <number>]
fd71d65c 294[-g|--get] [-h|--help] [--ftp] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
ccb03bc0 295[-q|--quiet] [--date <yyyy-mm-dd> [-r <tag>] [{-T|--tag <tag>]
a7b2951c 296[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
b3b584c5 297[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d 298[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 299[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
ccb03bc0 300<package>[.spec][:tag]
2a5f078d 301
647fead0
ER
302-4 - force IPv4 when transferring files
303-6 - force IPv6 when transferring files
304-5,
305--update-md5 - update md5 comments in spec, implies -nd -ncs
306-a5,
307--add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
4ca1edbd 308--all-branches - make shallow fetch of all branches; --depth required
cd445739 309-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
310-D, --debug - enable builder script debugging mode,
311-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
312-V, --version - output builder version string
313--short-version - output builder short version
647fead0
ER
314-a - try add new package to PLD repo.
315-b,
316-ba
317 - get all files from PLD repo or HTTP/FTP and build package
cd445739 318 from <package>.spec,
647fead0 319-bb - get all files from PLD repo or HTTP/FTP and build binary
cd445739 320 only package from <package>.spec,
647fead0 321-bp - execute the %prep phase of <package>.spec,
6594293d
AG
322-bc - execute the %build phase of <package>.spec,
323-bi - execute the %install phase of <package>.spec
4ca1edbd 324-bl - execute the %files phase of <package>.spec
647fead0 325-bs - get all files from PLD repo or HTTP/FTP and only pack
cd445739 326 them into src.rpm,
6594293d 327--short-circuit - short-circuit build
cd445739 328-B, --branch - add branch
647fead0
ER
329-c,
330--clean - clean all temporarily created files (in BUILD\$RPM_BUILD_ROOT) after rpmbuild commands.
387eaf99 331 may be used with building process.
6f10b394 332-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
4ca1edbd
KK
333 SPECS and \$RPM_BUILD_ROOT). Doesn't run any rpm building.
334-cf, --cvs-force - use -f when tagging
eccfb714 335--define '<macro> <value>'
cd445739 336 - define a macro <macro> with value <value>,
4ca1edbd 337--depth <number> - make shallow fetch
44058243
ER
338--alt_kernel <kernel>
339 - same as --define 'alt_kernel <kernel>'
cd445739 340--nodeps - rpm won't check any dependences
647fead0
ER
341-g
342--get - get <package>.spec and all related files from PLD repo
cd445739 343-h, --help - this message,
647fead0
ER
344-j N - set %_smp_mflags to propagate concurrent jobs
345--ftp - use FTP protocol to access distfiles server
346--http - use HTTP protocol to access distfiles server
347-l <logfile>, --logtofile=<logfile>
cd445739 348 - log all to file,
cd445739 349-ncs, --no-cvs-specs
ccb03bc0 350 - don't pull from PLD repo
cd445739
AM
351-nd, --no-distfiles - don't download from distfiles
352-nm, --no-mirrors - don't download from mirror, if source URL is given,
353-nu, --no-urls - don't try to download from FTP/HTTP location,
7cbc2d88 354-ns, --no-srcs - don't download Sources/Patches
cd445739
AM
355-ns0, --no-source0 - don't download Source0
356-nn, --no-net - don't download anything from the net
647fead0 357-p N - set PARALLEL_DOWNLOADS to N (default $PARALLEL_DOWNLOADS)
4ca1edbd
KK
358-pm, --prefer-mirrors
359 - prefer mirrors (if any) over distfiles for SOURCES
b572253e 360--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d 361-ske,
4ca1edbd
KK
362--skip-existing-files
363 - skip existing files in get_files
cd445739
AM
364--opts <rpm opts> - additional options for rpm
365-q, --quiet - be quiet,
ccb03bc0
KK
366--date yyyy-mm-dd - build package using resources from specified date,
367-r <tag>, --cvstag <ref>
368 - build package using resources from specified branch/tag,
5053a974 369-A - build package using master branch as any sticky tags/branch/date being reset.
cd445739
AM
370-R, --fetch-build-requires
371 - fetch what is BuildRequired,
372-RB, --remove-build-requires
373 - remove all you fetched with -R or --fetch-build-requires
374 remember, this option requires confirmation,
375-FRB, --force-remove-build-requires
376 - remove all you fetched with -R or --fetch-build-requires
377 remember, this option works without confirmation,
4ca1edbd
KK
378-sd, --source-distfiles
379 - list sources available from distfiles (intended for offline
06541433
JR
380 operations; does not work when Icon field is present
381 but icon file is absent),
4ca1edbd
KK
382-sc, --source-cvs - list sources available from PLD repo
383-sdp, --source-distfiles-paths
384 - list sources available from distfiles -
06541433
JR
385 paths relative to distfiles directory (intended for offline
386 operations; does not work when Icon field is present
387 but icon file is absent),
a7eefc54 388-sf, --source-files - list sources - bare filenames (intended for offline
389 operations; does not work when Icon field is present
3621e588 390 but icon file is absent),
4ca1edbd
KK
391-lsp, --source-paths
392 - list sources - filenames with full local paths (intended for
a7eefc54 393 offline operations; does not work when Icon field is present
3621e588 394 but icon file is absent),
2dddf439
ER
395-su, --source-urls - list urls - urls to sources and patches
396 intended for copying urls with spec with lots of macros in urls
ccb03bc0
KK
397-T <tag> , --tag <tag>
398 - add git tag <tag> for files,
cd445739 399-Tvs, --tag-version-stable
ccb03bc0 400 - add git tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 401-Ts, --tag-stable
ccb03bc0 402 - add git tag STABLE for files,
647fead0
ER
403-Tv,
404--tag-version - add git tag NAME-VERSION-RELEASE for files,
cd445739
AM
405-Tp, --tag-prefix <prefix>
406 - add <prefix> to NAME-VERSION-RELEASE tags,
407-tt, --test-tag <prefix>
408 - fail if tag is already present,
50321881
JK
409-ir, --integer-release-only
410 - allow only integer and snapshot releases
cd445739
AM
411-v, --verbose - be verbose,
412-u, --try-upgrade - check version, and try to upgrade package
413-un, --try-upgrade-with-float-version
414 - as above, but allow float version
4ca1edbd 415 php-pear-Services_Digg/
0907f1eb 416--upgrade-version - upgrade to specified version in try-upgrade
deccc50e 417-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
418-Upi, --update-poldek-indexes
419 - refresh or make poldek package index files.
647fead0
ER
420-sp <patchnumber>,
421--skip-patch <patchnumber>
8bd5e66d 422 - don't apply <patchnumber>. may be repeated.
647fead0
ER
423-np <patchnumber>,
424--nopatch <patchnumber>
8bd5e66d 425 - abort instead of applying patch <patchnumber>
fc8edbe5
ER
426--noinit
427 - do not initialize SPECS_DIR and SOURCES_DIR (set them to .)
dfe2cb9a
MK
428--show-bconds - show available conditional builds, which can be used
429 - with --with and/or --without switches.
b05205af
BZ
430--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by ./repackage.sh script.
431 In other words, the output is parseable by scripts.
24a97174 432--show-avail-bconds - show available bconds
647fead0
ER
433--with <feature>,
434--without <feature>
cd445739
AM
435 - conditional build package depending on %_with_<feature>/
436 %_without_<feature> macro switch. You may now use
437 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
438 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 439--target <platform>, --target=<platform>
a6494cd4
ER
440 - build for platform <platform>.
441--init-rpm-dir - initialize ~/rpm directory structure
5a491465 442"
443}
444
390d081d
ER
445# create tempfile. as secure as possible
446tempfile() {
ff5e57ba 447 mktemp --tmpdir -t builder.$PACKAGE_NAME.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM.$$
390d081d
ER
448}
449
397fa865 450tempdir() {
ff5e57ba 451 mktemp --tmpdir -d builder.$PACKAGE_NAME.XXXXXX
397fa865
KK
452}
453
8cc8f5c0
ER
454# inserts git log instead of %changelog
455# outputs name of modified file created by tempfile
456insert_gitlog() {
397fa865 457 local SPECFILE=$1 specdir=$(tempdir) gitlog=$(tempfile) speclog=$(tempfile)
8cc8f5c0
ER
458
459 # allow this being customized
460 local log_entries=$(rpm -E '%{?_buildchangelogtruncate}')
461
462 # rpm5.org/rpm.org do not parse any other date format than 'Wed Jan 1 1997'
463 # otherwise i'd use --date=iso here
464 # http://rpm5.org/cvs/fileview?f=rpm/build/parseChangelog.c&v=2.44.2.1
465 # http://rpm.org/gitweb?p=rpm.git;a=blob;f=build/parseChangelog.c#l31
466 # NOTE: changelog date is always in UTC for rpmbuild
467 # * 1265749244 +0000 Random Hacker <nikt@pld-linux.org> 9370900
9fd1eb80 468 git rev-list --date-order -${log_entries:-20} HEAD 2>/dev/null | while read sha1; do
f8704064 469 local logfmt='%B%n'
fafbe559 470 git notes list $sha1 > /dev/null 2>&1 && logfmt=%N
f8704064 471 git log -n 1 $sha1 --format=format:"* %ad %an <%ae> %h%n${logfmt}%n" --date=raw | sed '/^$/q'
9c0fe78c 472 done > $gitlog
9e269b3c
ER
473
474 # add link to full git logs
475 local giturl="http://git.pld-linux.org/?p=packages/$PACKAGE_NAME.git;a=log"
476 if [ -n "$CVSTAG" ]; then
477 giturl="$giturl;h=$CVSTAG"
478 fi
479 local gitauthor="PLD Linux Team <feedback@pld-linux.org>"
480 LC_ALL=C gawk -vgiturl="$giturl" -vgitauthor="$gitauthor" -vpackage=$PACKAGE_NAME 'BEGIN{
481 printf("* %s %s\n- For complete changelog see: %s\n", strftime("%a %b %d %Y"), gitauthor, giturl);
482 print;
483 exit
484 }' > $speclog
485
486 LC_ALL=C gawk '/^\* /{printf("* %s %s\n", strftime("%a %b %d %Y", $2), substr($0, length($1)+length($2)+length($3)+4)); next}{print}' $gitlog >> $speclog
8cc8f5c0
ER
487 sed '/^%changelog/,$d' $SPECFILE | sed -e "\${
488 a%changelog
489 r $speclog
490 }
397fa865 491 " > $specdir/$SPECFILE
8cc8f5c0 492 rm -f $gitlog $speclog
397fa865 493 echo $specdir
8cc8f5c0
ER
494}
495
31d2bd0b
ER
496# change dependency to specname
497# common changes:
498# - perl(Package::Name) -> perl-Package-Name
499depspecname() {
500 local package="$1"
501
560c4b1a 502 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g};' -e 's/-\(devel\|static\)$//' )
31d2bd0b
ER
503 echo "$package"
504}
505
c890b916 506update_shell_title() {
a0d6396b 507 [ -t 1 ] || return
0b65d15e 508 local len=${COLUMNS:-80}
5c795f16 509 local msg="$(echo "$*" | cut -c-$len)"
0b65d15e 510
e225de91
ER
511 if [ -n "$BE_VERBOSE" ]; then
512 echo >&2 "$(date +%s.%N) $*"
513 fi
514
5c795f16 515 if [ "x$TITLECHANGE" = "xyes" -o "x$TITLECHANGE" = "x" ]; then
138bbc98
ER
516 local pkg
517 if [ -n "$PACKAGE_NAME" ]; then
518 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
519 else
520 pkg=${SPECFILE}
521 fi
522
523 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
a8c9a155 524 msg=$(echo $msg | tr -d '\n\r')
982e358c
MP
525 case "$TERM" in
526 cygwin|xterm*)
527 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
528 ;;
529 screen*)
530 echo >&2 -ne "\033]0;$msg\007"
531 ;;
532 esac
533 fi
c890b916
ER
534}
535
7e40520f
ER
536# set TARGET from BuildArch: from SPECFILE
537set_spec_target() {
ce40491a 538 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
8c91ee46 539 local tmp=$(awk '/^BuildArch:/ { print $NF; exit }' $ASSUMED_NAME/$SPECFILE)
ce40491a 540 if [ "$tmp" ]; then
8c91ee46 541 local target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
542 TARGET="$tmp"
543 case "$RPMBUILD" in
544 "rpmbuild")
f9109a96 545 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 546 "rpm")
ce40491a 547 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 548 esac
ce40491a
ER
549 fi
550 fi
7e40520f
ER
551}
552
ace3fd80
ER
553# runs rpm with minimal macroset
554minirpm() {
fa4bf1df 555 # we reset macros not to contain macros.build as all the %() macros are
559d511f 556 # executed here, while none of them are actually needed.
559d511f 557 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
525bf240 558 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
559
560 # TODO: move these to /usr/lib/rpm/macros
20117088 561 cat > $BUILDER_MACROS <<'EOF'
5b5e5f7f 562%x8664 x86_64 amd64 ia32e
f78a0bb7 563%alt_kernel %{nil}
564%_alt_kernel %{nil}
5ff15c97 565%bootstrap_release() %{1}
407b204b
ER
566%requires_releq_kernel_up(s:n:) %{nil}
567%requires_releq_kernel_smp(s:n:) %{nil}
568%requires_releq_kernel(s:n:) %{nil}
6b8134e3 569%requires_releq() %{nil}
bb01dee9 570%pyrequires_eq() %{nil}
559d511f 571%requires_eq() %{nil}
c13be3d1 572%requires_eq_to() %{nil}
99c05e13 573%requires_ge() %{nil}
500b0eb8
ER
574%requires_ge_to() %{nil}
575%requires_ge() %{nil}
407b204b
ER
576%releq_kernel_up(n:) ERROR
577%releq_kernel_smp(n:) ERROR
578%releq_kernel(n:) ERROR
74d9fd14 579%kgcc_package ERROR
237bd3f1 580%_fontsdir ERROR
7141278d 581%ruby_version ERROR
582%ruby_ver_requires_eq() %{nil}
583%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 584%__php_api_requires() %{nil}
7141278d 585%php_major_version ERROR
586%php_api_version ERROR
99f819cf
AM
587%requires_xorg_xserver_extension %{nil}
588%requires_xorg_xserver_xinput %{nil}
589%requires_xorg_xserver_font %{nil}
590%requires_xorg_xserver_videodrv %{nil}
7141278d 591%py_ver ERROR
41035426
ER
592%perl_vendorarch ERROR
593%perl_vendorlib ERROR
703ae20b
ER
594# damn. need it here! - copied from /usr/lib/rpm/macros.build
595%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
596%patchset_source(f:b:) %(
597 base=%{-b*}%{!-b*:10000};
598 start=$(expr $base + %1);
599 end=$(expr $base + %{?2}%{!?2:%{1}});
600 # we need to call seq twice as it doesn't allow two formats
601 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
602 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
603 paste %{tmpdir}/__ps{1,2};
604 rm -f %{tmpdir}/__ps{1,2};
605) \
606%{nil}
991f09a5
ER
607%add_etc_shells(p) %{p:<lua>}
608%remove_etc_shells(p) %{p:<lua>}
709995c4
ER
609%lua_add_etc_shells() %{nil}
610%lua_remove_etc_shells() %{nil}
0ca65fa4
JK
611%required_jdk %{nil}
612%buildrequires_jdk %{nil}
f9063abe 613%pear_package_print_optionalpackages %{nil}
fb198857 614EOF
3d12d055 615 if [ "$NOINIT" = "yes" ] ; then
20117088 616 cat >> $BUILDER_MACROS <<'EOF'
3d12d055
JR
617%_specdir ./
618%_sourcedir ./
619EOF
c039643c 620 fi
670b1ed4 621 eval PATH=$CLEAN_PATH $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
ace3fd80
ER
622}
623
624cache_rpm_dump() {
625 if [ -n "$DEBUG" ]; then
626 set -x
627 set -v
628 fi
629
d1d24c14 630 if [ -x /usr/bin/rpm-specdump ]; then
525bf240 631 update_shell_title "cache_rpm_dump using rpm-specdump command"
646d81cf 632 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND --define "_specdir $PACKAGE_DIR" --define "_sourcedir $PACKAGE_DIR" $PACKAGE_DIR/$SPECFILE)
d1d24c14 633 else
525bf240 634 update_shell_title "cache_rpm_dump using rpmbuild command"
d1d24c14
ER
635 local rpm_dump
636 rpm_dump=`
637 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
638 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
639 case "$RPMBUILD" in
640 rpm)
641 ARGS='-bp'
642 ;;
643 rpmbuild)
644 ARGS='--nodigest --nosignature --nobuild'
645 ;;
646 esac
647 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
648 `
649 if [ $? -gt 0 ]; then
650 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
651 echo "$error" >&2
652 Exit_error err_build_fail
653 fi
d05e8080 654
d1d24c14
ER
655 # make small dump cache
656 rpm_dump_cache=`echo "$rpm_dump" | awk '
657 $2 ~ /^SOURCEURL/ {print}
658 $2 ~ /^PATCHURL/ {print}
659 $2 ~ /^nosource/ {print}
660 $2 ~ /^PACKAGE_/ {print}
661 '`
662 fi
d05e8080 663
13974367 664 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
665}
666
ace3fd80 667rpm_dump() {
cd445739 668 if [ -z "$rpm_dump_cache" ] ; then
45e2a818 669 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
cd445739
AM
670 fi
671 echo "$rpm_dump_cache"
672}
673
f6711e2a 674get_icons() {
d05e8080 675 update_shell_title "get icons"
9d99a240 676 ICONS=$(awk '/^Icon:/ {print $2}' $PACKAGE_DIR/${SPECFILE})
d05e8080
ER
677 if [ -z "$ICONS" ]; then
678 return
679 fi
680
975d7b23 681 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
682}
683
f6711e2a 684parse_spec() {
af4d5315 685 update_shell_title "parsing specfile"
cd445739 686 if [ -n "$DEBUG" ]; then
518ff1fb
ER
687 set -x
688 set -v
cd445739 689 fi
b2975fc3 690
d05e8080 691 # icons are needed for successful spec parse
518ff1fb 692 get_icons
d05e8080 693
9c909460 694 cd $PACKAGE_DIR
cd445739 695 cache_rpm_dump
00fcec7e 696
15e34b63 697 if rpm_dump | grep -qEi ":.*nosource.*1"; then
cd445739
AM
698 FAIL_IF_NO_SOURCES="no"
699 fi
700
7cbc2d88
ER
701 if [ "$NOSRCS" != "yes" ]; then
702 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
703 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
704 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
705 fi
706
dfe2b2d9
ER
707 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
708 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
709 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 710
0b4119a2 711 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
7854d40c 712 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
0b4119a2
JR
713 fi
714
cd445739
AM
715 if [ -n "$BE_VERBOSE" ]; then
716 echo "- Sources : `nourl $SOURCES`"
717 if [ -n "$PATCHES" ]; then
718 echo "- Patches : `nourl $PATCHES`"
719 else
720 echo "- Patches : *no patches needed*"
721 fi
722 if [ -n "$ICONS" ]; then
723 echo "- Icon : `nourl $ICONS`"
724 else
725 echo "- Icon : *no package icon*"
726 fi
727 echo "- Name : $PACKAGE_NAME"
728 echo "- Version : $PACKAGE_VERSION"
729 echo "- Release : $PACKAGE_RELEASE"
730 fi
13974367
ER
731
732 update_shell_title "parse_spec: OK!"
cd445739
AM
733}
734
f6711e2a 735Exit_error() {
cd445739 736 if [ -n "$DEBUG" ]; then
518ff1fb
ER
737 set -x
738 set -v
cd445739
AM
739 fi
740
741 cd "$__PWD"
742
743 case "$1" in
744 "err_no_spec_in_cmdl" )
745 remove_build_requires
45e2a818 746 echo >&2 "ERROR: spec file name not specified."
cd445739 747 exit 2 ;;
a08d92fc 748 "err_invalid_cmdline" )
45e2a818 749 echo >&2 "ERROR: invalid command line arg ($2)."
a08d92fc 750 exit 2 ;;
cd445739
AM
751 "err_no_spec_in_repo" )
752 remove_build_requires
bba21388 753 echo >&2 "Error: spec file not stored in PLD repo."
cd445739
AM
754 exit 3 ;;
755 "err_no_source_in_repo" )
756 remove_build_requires
bba21388 757 echo >&2 "Error: some source, patch or icon files not stored in PLD repo. ($2)"
cd445739 758 exit 4 ;;
703b6deb 759 "err_cvs_add_failed" )
bba21388 760 echo >&2 "Error: failed to add package to PLD repo."
703b6deb 761 exit 4 ;;
cd445739
AM
762 "err_build_fail" )
763 remove_build_requires
45e2a818 764 echo >&2 "Error: package build failed. (${2:-no more info})"
cd445739 765 exit 5 ;;
78eab2a1
AM
766 "err_no_package_data" )
767 remove_build_requires
45e2a818 768 echo >&2 "Error: couldn't get out package name/version/release from spec file."
78eab2a1 769 exit 6 ;;
ce40491a 770 "err_tag_exists" )
50321881 771 remove_build_requires
d2842af2 772 echo >&2 "Tag ${2} already exists"
50321881 773 exit 9 ;;
ce40491a 774 "err_fract_rel" )
50321881 775 remove_build_requires
45e2a818 776 echo >&2 "Release ${2} not integer and not a snapshot."
50321881 777 exit 10 ;;
fb96e0b5
AM
778 "err_branch_exists" )
779 remove_build_requires
45e2a818 780 echo >&2 "Tree branch already exists (${2})."
fb96e0b5 781 exit 11 ;;
cfc497c0
ER
782 "err_acl_deny" )
783 remove_build_requires
45e2a818 784 echo >&2 "Error: conditions reject building this spec (${2})."
cfc497c0 785 exit 12 ;;
406b9ecf
KK
786 "err_remote_problem" )
787 remove_build_requires
788 echo >&2 "Error: problem with remote (${2})"
789 exit 13 ;;
6217f407
KK
790 "err_no_checkut" )
791 echo >&2 "Error: cannot checkout $2"
792 exit 14 ;;
67963237 793 "err_not_implemented" )
779fcca4 794 remove_build_requires
67963237
KK
795 echo >&2 "Error: functionality not yet imlemented"
796 exit 110 ;;
cd445739 797 esac
45e2a818 798 echo >&2 "Unknown error."
73848362 799 exit 100
cd445739
AM
800}
801
f6711e2a 802init_builder() {
cd445739 803 if [ -n "$DEBUG" ]; then
518ff1fb
ER
804 set -x
805 set -v
0dd6320d 806 fi
cd445739 807
4aeb9973 808 if [ "$NOINIT" != "yes" ] ; then
9c909460 809 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
b7cc0c94 810
09bf17c9 811 local macros_ver=$(rpm -E %?rpm_build_macros)
b7cc0c94
ER
812 if [ -z "$macros_ver" ]; then
813 REPO_DIR=$TOP_DIR/packages
814 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
815 else
816 if awk "BEGIN{exit($macros_ver>=$RPM_MACROS_VER)}"; then
817 echo >&2 "builder requires rpm-build-macros >= $RPM_MACROS_VER"
818 exit 1
819 fi
820 REPO_DIR=$TOP_DIR
821 PACKAGE_DIR=$REPO_DIR/$ASSUMED_NAME
822 fi
29e90b02 823 else
9c909460
AM
824 REPO_DIR="."
825 PACKAGE_DIR="."
29e90b02 826 fi
52f3ced3
KK
827 export GIT_WORK_TREE=$PACKAGE_DIR
828 export GIT_DIR=$PACKAGE_DIR/.git
cd445739 829
acd0d41d 830 if [ -d "$GIT_DIR" ] && [ -z "$CVSTAG" ] && git rev-parse --verify -q HEAD > /dev/null; then
a095de80
KK
831 if CVSTAG=$(GIT_DIR=$GIT_DIR git symbolic-ref HEAD) 2>/dev/null; then
832 CVSTAG=${CVSTAG#refs/heads/}
833 if [ "$CVSTAG" != "master" ]; then
834 echo >&2 "builder: Active branch $CVSTAG. Use -r BRANCHNAME to override"
835 fi
836 else
837 echo >&2 "On detached HEAD. Use -r BRANCHNAME to override"
838 HEAD_DETACHED="yes"
839 fi
840 elif [ "$CVSTAG" = "HEAD" ]; then
841 # assume -r HEAD is same as -A
842 CVSTAG="master"
843 fi
844
a8c9a155 845 __PWD=$(pwd)
00fcec7e 846}
847
406b9ecf
KK
848create_git_repo() {
849 update_shell_title "add_package"
850
851 if [ -n "$DEBUG" ]; then
852 set -x
853 set -v
854 fi
855
856 cd "$REPO_DIR"
857 SPECFILE=$(basename $SPECFILE)
858 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
859 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
860 exit 101
861 fi
862 [ -d "$ASSUMED_NAME/.git" ] || NEW_REPO=yes
c6418b06 863 ssh $GIT_PUSH create ${ASSUMED_NAME} || Exit_error err_cvs_add_failed
406b9ecf 864 git init
eda17ab7
KK
865 git remote add $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git && \
866 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME} \
867 || Exit_error err_remote_problem $REMOTE_PLD
406b9ecf
KK
868}
869
f6711e2a 870get_spec() {
c890b916 871
2e5be021 872 update_shell_title "get_spec"
c890b916 873
cd445739 874 if [ -n "$DEBUG" ]; then
518ff1fb
ER
875 set -x
876 set -v
cd445739
AM
877 fi
878
9c909460 879 cd "$REPO_DIR"
cd445739 880
1ef6f5de 881 if [ "$NOCVSSPEC" != "yes" ]; then
3189511a 882 if [ -z "$DEPTH" ]; then
30419e36 883 if [ -d "$PACKAGE_DIR/.git" ]; then
608c01a7 884 git fetch $REMOTE_PLD || Exit_error err_no_spec_in_repo
3189511a 885 elif [ "$ADD_PACKAGE_CVS" = "yes" ]; then
30419e36
ER
886 if [ ! -r "$PACKAGE_DIR/$SPECFILE" ]; then
887 echo "ERROR: No package to add ($PACKAGE_DIR/$SPECFILE)" >&2
3189511a
KK
888 exit 101
889 fi
890 Exit_error err_not_implemented
891 else
892 (
893 unset GIT_WORK_TREE
eda17ab7 894 git clone -o $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git || {
588cb3a9 895 # softfail if new package, i.e not yet added to PLD rep
30419e36 896 [ ! -f "$PACKAGE_DIR/$SPECFILE" ] && Exit_error err_no_spec_in_repo
3189511a
KK
897 echo "Warning: package not in CVS - assuming new package"
898 NOCVSSPEC="yes"
899 }
dd30f9c8 900 git config --local --add "remote.$REMOTE_PLD.fetch" 'refs/notes/*:refs/notes/*'
eda17ab7 901 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME}
3189511a 902 )
703b6deb 903 fi
9c909460 904 else
30419e36
ER
905 if [ ! -d "$PACKAGE_DIR/.git" ]; then
906 if [ ! -d "$PACKAGE_DIR" ]; then
907 install -d $PACKAGE_DIR
3189511a
KK
908 fi
909 git init
a153a767 910 git remote add $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git
dd30f9c8 911 git config --local --add "remote.$REMOTE_PLD.fetch" 'refs/notes/*:refs/notes/*'
48184c96 912 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME}
6a9f8358 913 CVSTAG=${CVSTAG:-"master"}
3189511a 914 fi
3f79cb18
KK
915 local refs=''
916 if [ -z "$ALL_BRANCHES" ]; then
917 refs="${CVSTAG}:remotes/${REMOTE_PLD}/${CVSTAG}"
918 fi
919 git fetch $DEPTH $REMOTE_PLD $refs || {
3189511a
KK
920 echo >&2 "Error: branch $CVSTAG does not exist"
921 exit 3
922 }
703b6deb 923 fi
f343238b 924 git fetch $REMOTE_PLD 'refs/notes/*:refs/notes/*'
0c3beb90 925
0d494abd 926 cvsignore_df .gitignore
703b6deb 927
588cb3a9 928 # add default log format to .gitignore if it is relative to package dir
703b6deb
ER
929 if [ -n "$LOGFILE" -a "$LOGFILE" = "${LOGFILE##*/}" ]; then
930 # substitute known "macros" to glob
52aad137 931 local logfile=$(echo "$LOGFILE" | sed -e 's,\$\(PACKAGE_NAME\|DATE\|TARGET\),*,g')
703b6deb
ER
932 if [ "$logfile" ]; then
933 cvsignore_df "$logfile"
daeab113 934 fi
9c909460 935 fi
703b6deb
ER
936
937 # create symlinks for tools
30419e36 938 if [ "$SYMLINK_TOOLS" != "no" -a -d "$PACKAGE_DIR" ]; then
2a8bedf9 939 for a in dropin md5 adapter builder {relup,compile,repackage,rsync,pearize}.sh pldnotify.awk; do
046b715f 940 # skip tools that don't exist in top dir
703b6deb 941 [ -f $a ] || continue
046b715f 942 # skip tools that already exist
30419e36
ER
943 [ -f $PACKAGE_DIR/$a ] && continue
944 ln -s ../$a $PACKAGE_DIR
703b6deb
ER
945 cvsignore_df $a
946 done
947 fi
cd445739 948 fi
049ab214 949
b0121b45 950 if [ -n "$CVSTAG" ]; then
6217f407
KK
951 if git rev-parse --verify -q "$CVSTAG"; then
952 git checkout "$CVSTAG" --
953 elif git rev-parse --verify -q "refs/remotes/${REMOTE_PLD}/$CVSTAG"; then
954 git checkout -t "refs/remotes/${REMOTE_PLD}/$CVSTAG" > /dev/null
955 fi
956 if [ $(git rev-parse "$CVSTAG") != $(git rev-parse HEAD) ]; then
957 Exit_error "err_no_checkut" "$CVSTAG"
958 fi
ef4c7d3d 959 git merge --ff-only '@{u}'
2226518e 960 git symbolic-ref -q HEAD > /dev/null && [ "$NOCVSSPEC" != "yes" ] &&
52020f4c 961 if [ -n "$CVSDATE" ]; then
c4c0f339
KK
962 git checkout $(git rev-list -n1 --before="'$CVSDATE'" $CVSTAG) || exit 1
963 fi
b0121b45
KK
964 fi
965
30419e36 966 if [ ! -f "$PACKAGE_DIR/$SPECFILE" ]; then
518ff1fb 967 Exit_error err_no_spec_in_repo
cd445739
AM
968 fi
969
970 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
30419e36 971 chmod $CHMOD_MODE $PACKAGE_DIR/$SPECFILE
cd445739
AM
972 fi
973 unset OPTIONS
30419e36 974 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $PACKAGE_DIR/$SPECFILE
7e40520f 975
ce40491a 976 set_spec_target
cd445739
AM
977}
978
f6711e2a 979find_mirror() {
9c909460 980 cd "$REPO_DIR"
782518da 981 local url="$1"
3526abd9 982 if [ ! -f "mirrors" ] ; then
b11920fb 983 ln -s ../rpm-build-tools/mirrors .
cd445739
AM
984 fi
985
986 IFS="|"
782518da
ER
987 local origin mirror name rest ol prefix
988 while read origin mirror name rest; do
989 # skip comments and empty lines
2faa4c32 990 if [ -z "$origin" ] || [ "${origin#\#}" != "$origin" ]; then
782518da
ER
991 continue
992 fi
a8c9a155
ER
993 ol=$(echo -n "$origin" | wc -c)
994 prefix=$(echo -n "$url" | head -c $ol)
cd445739 995 if [ "$prefix" = "$origin" ] ; then
a8c9a155 996 suffix=$(echo "$url" | cut -b $((ol+1))-)
cd445739
AM
997 echo -n "$mirror$suffix"
998 return 0
999 fi
1000 done < mirrors
1001 echo "$url"
1002}
1003
e7e0d4ec 1004# Warning: unpredictable results if same URL used twice
f6711e2a 1005src_no() {
8510980a
AM
1006 local file="$1"
1007 # escape some regexp characters if part of file name
298e75e2 1008 file=$(echo "$file" | sed -e 's#\([\+\*\.\&\#\?]\)#\\\1#g')
9c909460 1009 cd $PACKAGE_DIR
cd445739 1010 rpm_dump | \
8510980a 1011 grep -E "(SOURCE|PATCH)URL[0-9]*[ ]*${file}""[ ]*$" | \
647e3d7f
KK
1012 sed -e 's/.*\(SOURCE\|PATCH\)URL\([0-9][0-9]*\).*/\1\2/' | \
1013 head -n 1 | tr OURCEATH ourceath | xargs
1471f6d6 1014}
1015
f6711e2a 1016src_md5() {
e7e0d4ec 1017 [ "$NO5" = "yes" ] && return
cd445739
AM
1018 no=$(src_no "$1")
1019 [ -z "$no" ] && return
9c909460 1020 cd $PACKAGE_DIR
e7e0d4ec
ER
1021 local md5
1022
1023 if [ -f additional-md5sums ]; then
e7e0d4ec 1024 md5=$(grep -s -v '^#' additional-md5sums | \
9413a514 1025 grep -E "[ ]$(basename "$1")([ ,]|\$)" | \
e7e0d4ec
ER
1026 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
1027 grep -E '^[0-9a-f]{32}$')
1028
1029 if [ "$md5" ]; then
1030 if [ $(echo "$md5" | wc -l) != 1 ] ; then
1031 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
1032 fi
1033 echo "$md5" | tail -n 1
1034 return
1035 fi
cd445739 1036 fi
e7e0d4ec 1037
32131a0e 1038 source_md5=$(grep -iE "^#[ ]*(No)?$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://')
e7e0d4ec
ER
1039 if [ -n "$source_md5" ]; then
1040 echo $source_md5
cd445739 1041 else
7805dcb4
PZ
1042 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
1043 if [ -n "$source_md5" ]; then
1044 echo $source_md5
1045 else
1046 # we have empty SourceX-md5, but it is still possible
1047 # that we have NoSourceX-md5 AND NoSource: X
647e3d7f 1048 nosource_md5=`grep -i "^#[ ]*No$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
7805dcb4
PZ
1049 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
1050 echo $nosource_md5
1051 fi
cd445739 1052 fi
cd445739
AM
1053 fi
1054}
1055
f6711e2a 1056distfiles_path() {
06541433
JR
1057 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
1058}
1059
f6711e2a 1060distfiles_url() {
06541433 1061 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
1062}
1063
f6711e2a 1064distfiles_attic_url() {
06541433 1065 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
1066}
1067
f6711e2a 1068good_md5() {
cd445739
AM
1069 md5=$(src_md5 "$1")
1070 [ "$md5" = "" ] || \
1071 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
1072}
1073
f6711e2a 1074good_size() {
a8c9a155 1075 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
ce40491a 1076 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
1077}
1078
f6711e2a 1079cvsignore_df() {
947025e5 1080 if [ "$CVSIGNORE_DF" != "yes" ]; then
1081 return
1082 fi
0d494abd 1083 cvsignore=${PACKAGE_DIR}/.gitignore
7dc8d095
ER
1084
1085 # add only if not yet there
aa189b05 1086 if ! awk -vf="$1" -vc=1 '$0 == f { c = 0 } END { exit c }' $cvsignore 2>/dev/null; then
947025e5 1087 echo "$1" >> $cvsignore
1088 fi
1089}
1090
71f8e908 1091# returns true if "$1" is ftp, http or https protocol url
f6711e2a 1092is_url() {
71f8e908
ER
1093 case "$1" in
1094 ftp://*|http://*|https://*)
1095 return 0
1096 ;;
1097 esac
1098 return 1
1099}
1100
f6711e2a 1101update_md5() {
ecba6ad5
ER
1102 if [ $# -eq 0 ]; then
1103 return
1104 fi
1105
1106 update_shell_title "update md5"
1107 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1108 set -x
1109 set -v
ecba6ad5
ER
1110 fi
1111
9c909460 1112 cd "$PACKAGE_DIR"
ecba6ad5
ER
1113
1114 # pass 1: check files to be fetched
1115 local todo
1116 local need_files
1117 for i in "$@"; do
1118 local fp=$(nourl "$i")
1119 local srcno=$(src_no "$i")
6392b5fd
ER
1120 if [ -n "$ADD5" ]; then
1121 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
647e3d7f 1122 grep -qiE '^#[ ]*'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
9c909460 1123 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
6392b5fd 1124 else
647e3d7f 1125 grep -qiE '^#[ ]*'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
ecba6ad5
ER
1126 fi
1127 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1128 need_files="$need_files $i"
1129 fi
1130 done
1131
1132 # pass 1a: get needed files
1133 if [ "$need_files" ]; then
1134 get_files $need_files
1135 fi
1136
1137 # pass 2: proceed with md5 adding or updating
1138 for i in "$@"; do
1139 local fp=$(nourl "$i")
1140 local srcno=$(src_no "$i")
647e3d7f 1141 local md5=$(grep -iE '^#[ ]*(No)?'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
e19ad799 1142 if [ -z "$md5" ]; then
9c909460 1143 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
6c1b2e7d 1144 fi
71f8e908 1145 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
647e3d7f 1146 local tag="# $srcno-md5:\t"
71f8e908 1147 if [[ "$md5" == *NoSource* ]]; then
6663e1f3 1148 tag="# No$srcno-md5:\t"
6c1b2e7d
PZ
1149 elif [ -n "$USEDIGEST" ]; then
1150 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
71f8e908 1151 fi
ecba6ad5 1152 md5=$(md5sum "$fp" | cut -f1 -d' ')
647e3d7f 1153 echo "Updating $srcno ($md5: $fp)."
ecba6ad5 1154 perl -i -ne '
647e3d7f
KK
1155 print unless (/^\s*#\s*(No)?'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
1156 print "'"$tag$md5"'\n" if /^'$srcno'\s*:\s+/i;
ecba6ad5 1157 ' \
9c909460 1158 $PACKAGE_DIR/$SPECFILE
ecba6ad5
ER
1159 fi
1160 done
1161}
1162
f6711e2a 1163check_md5() {
60499e54 1164 local bad
3fbff8b8
ER
1165 [ "$NO5" = "yes" ] && return
1166
ecba6ad5
ER
1167 update_shell_title "check md5"
1168
1169 for i in "$@"; do
60499e54
AM
1170 bad=0
1171 if ! good_md5 "$i"; then
1172 echo -n "MD5 sum mismatch."
1173 bad=1
1174 fi
1175 if ! good_size "$i"; then
1176 echo -n "0 sized file."
1177 bad=1
ecba6ad5
ER
1178 fi
1179
60499e54
AM
1180 if [ $bad -eq 1 ]; then
1181 echo " Use -U to refetch sources,"
1182 echo "or -5 to update md5 sums, if you're sure files are correct."
1183 Exit_error err_no_source_in_repo $i
1184 fi
ecba6ad5
ER
1185 done
1186}
1187
f6711e2a 1188get_files() {
7cb24972 1189 update_shell_title "get_files"
cd445739
AM
1190
1191 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1192 set -x
1193 set -v
cd445739
AM
1194 fi
1195
f09c0772 1196 if [ $# -gt 0 ]; then
9c909460 1197 cd "$PACKAGE_DIR"
cd445739 1198
f2e42a41 1199 local nc=0
e7fa3b9f 1200 local get_files_cvs=""
3815b69a 1201 for i in "$@"; do
f2e42a41 1202 nc=$((nc + 1))
dcebdffb 1203 local cvsup=0
3815b69a 1204 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 1205 update_shell_title "$i"
f09c0772 1206 local fp=`nourl "$i"`
ecba6ad5 1207 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 1208 continue
18e5347d 1209 fi
ecba6ad5 1210
cd445739 1211 FROM_DISTFILES=0
e7e0d4ec 1212 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
1213
1214 # we know if source/patch is present in cvs/distfiles
1215 # - has md5 (in distfiles)
1216 # - in cvs... ideas?
1217
1218 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 1219 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
1220 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1221 echo "Warning: no URL given for $i"
1222 fi
08908161 1223 target="$fp"
cd445739 1224
e7e0d4ec 1225 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 1226 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 1227 echo "$fp having proper md5sum already exists"
cd445739
AM
1228 continue
1229 fi
28b34560 1230
bc10f694 1231 # optionally prefer mirror over distfiles if there's mirror
28b34560 1232 # TODO: build url list and then try each url from the list
bc10f694 1233 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
28b34560
ER
1234 url="$im"
1235 else
1236 url=$(distfiles_url "$i")
1237 fi
1238
cd445739
AM
1239 url_attic=$(distfiles_attic_url "$i")
1240 FROM_DISTFILES=1
ecba6ad5
ER
1241 # is $url local file?
1242 if [[ "$url" = [./]* ]]; then
18a52930 1243 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
1244 ${GETLOCAL} $url $target
1245 else
9e9f8920
ER
1246 local uri=${url}
1247 # make shorter message for distfiles urls
1248 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1249 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1250 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1251 uri="df: $uri"
1252 fi
1253 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 1254 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1255 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 1256 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1257 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
1258 fi
1259 fi
ecba6ad5
ER
1260
1261 # is it empty file?
1262 if [ ! -s "$target" ]; then
cd445739
AM
1263 rm -f "$target"
1264 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 1265 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
1266 ${GETLOCAL} $url_attic $target
1267 else
18a52930 1268 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1269 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1270 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1271 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1272 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739 1273 fi
1cd7fc57 1274 test -s "$target" || rm -f "$target"
cd445739
AM
1275 fi
1276 fi
ecba6ad5
ER
1277
1278 if [ -s "$target" ]; then
947025e5 1279 cvsignore_df $target
1280 else
cd445739
AM
1281 rm -f "$target"
1282 FROM_DISTFILES=0
1283 fi
cd445739
AM
1284 fi
1285
f09c0772 1286 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739 1287 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1288 im=$(find_mirror "$i")
cd445739
AM
1289 else
1290 im="$i"
1291 fi
ce40491a 1292 update_shell_title "${GETURI%% *}: $im"
99b8f51f 1293 ${GETURI} ${OUTFILEOPT} "$target" "$im" || \
33da77c4 1294 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1295 update_shell_title "${GETURI2%% *}: $im"
99b8f51f 1296 ${GETURI2} ${OUTFILEOPT} "$target" "$im"
7e365483 1297 fi
1cd7fc57 1298 test -s "$target" || rm -f "$target"
cd445739
AM
1299 fi
1300
dcebdffb
ER
1301 if [ "$cvsup" = 1 ]; then
1302 continue
1303 fi
1304
cd445739 1305 fi
ecba6ad5
ER
1306
1307 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1308 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
b3b584c5 1309 Exit_error err_no_source_in_repo $i
cd445739 1310 fi
2a5f078d 1311
ecba6ad5 1312 # we check md5 here just only to refetch immediately
a4b50627 1313 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1314 :
1315 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1316 # wrong md5 from distfiles: remove the file and try again
cd445739 1317 # but only once ...
deccc50e 1318 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1319 FROM_DISTFILES=2
1320 rm -f $target
18a52930 1321 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1322 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1323 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1324 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1325 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1326 fi
ecba6ad5 1327 if [ ! -s "$target" ]; then
cd445739 1328 rm -f "$target"
18a52930 1329 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1330 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1331 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1332 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1333 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1334 fi
1335 fi
1336 test -s "$target" || rm -f "$target"
1337 fi
cd445739 1338 done
e7fa3b9f
ER
1339 SHELL_TITLE_PREFIX=""
1340
cd445739
AM
1341
1342 if [ "$CHMOD" = "yes" ]; then
a8c9a155 1343 CHMOD_FILES=$(nourl "$@")
cd445739
AM
1344 if [ -n "$CHMOD_FILES" ]; then
1345 chmod $CHMOD_MODE $CHMOD_FILES
1346 fi
1347 fi
cd445739
AM
1348 fi
1349}
1350
7605fe95 1351tag_exist() {
8b6d1795
KK
1352# If tag exists and points to other commit exit with error
1353# If it existsts and points to HEAD return 1
1354# If it doesn't exist return 0
f8bfce7d 1355 local _tag="$1"
8b6d1795 1356 local sha1=$(git rev-parse HEAD)
7605fe95
KK
1357 echo "Searching for tag $_tag..."
1358 if [ -n "$DEPTH" ]; then
8b6d1795 1359 local ref=$(git ls-remote $REMOTE_PLD "refs/tags/$_tag" | cut -c -40)
7605fe95 1360 else
7baf7b2f 1361 local ref=$(git show-ref -s "refs/tags/$_tag")
7605fe95 1362 fi
8b6d1795
KK
1363 [ -z "$ref" ] && return 0
1364 [ "$ref" = "$sha1" ] || Exit_error err_tag_exists "$_tag"
1365 return 1
7605fe95
KK
1366}
1367
cd445739 1368make_tagver() {
ce40491a 1369 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1370 set -x
1371 set -v
ce40491a 1372 fi
78eab2a1 1373
ce40491a
ER
1374 # Check whether first character of PACKAGE_NAME is legal for tag name
1375 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1376 TAG_PREFIX=tag_
1377 fi
d712cc12
ER
1378
1379 # NOTE: CVS tags may must not contain the characters `$,.:;@'
8c043136 1380 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE)
d712cc12 1381
8c043136 1382 # Remove @kernel.version_release from TAGVER because tagging sources
ce40491a 1383 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1384 # besides, %{_kernel_ver_str} is not expanded.
1385
8c043136 1386 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1@%{_kernel_ver_str}
d712cc12
ER
1387 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1388
8c043136 1389 TAGVER=${TAGVER%@*}
ce40491a 1390 echo -n "$TAGVER"
cd445739
AM
1391}
1392
f6711e2a 1393tag_files() {
cd445739 1394 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1395 set -x
1396 set -v
cd445739
AM
1397 fi
1398
73ef63d8
ER
1399 echo "Version: $PACKAGE_VERSION"
1400 echo "Release: $PACKAGE_RELEASE"
cd445739 1401
c9100f10 1402 local _tag
73ef63d8 1403 if [ "$TAG_VERSION" = "yes" ]; then
c9100f10 1404 _tag=`make_tagver`
73ef63d8
ER
1405 fi
1406 if [ -n "$TAG" ]; then
c9100f10 1407 _tag="$TAG"
73ef63d8 1408 fi
c9100f10 1409 echo "tag: $_tag"
cd445739 1410
39dcc7de 1411 local OPTIONS="tag $CVS_FORCE"
cd445739 1412
9c909460 1413 cd "$PACKAGE_DIR"
03db3356 1414
ace99bc6
KK
1415 if tag_exist $_tag || [ -n "$CVS_FORCE" ]; then
1416 update_shell_title "tag sources: $_tag"
1417 git $OPTIONS $_tag || exit
1418 git push $CVS_FORCE $REMOTE_PLD tag $_tag || Exit_error err_remote_problem $REMOTE_PLD
1419 else
1420 echo "Tag $_tag already exists and points to the same commit"
1421 fi
cd445739
AM
1422}
1423
f6711e2a 1424branch_files() {
cd445739 1425 TAG=$1
f663f264 1426 echo "Git branch: $TAG"
518ff1fb 1427 shift
cd445739 1428
cd445739 1429 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1430 set -x
1431 set -v
cd445739
AM
1432 fi
1433
f663f264 1434 local OPTIONS="branch $CVS_FORCE"
c10fa4fa 1435
9c909460 1436 cd "$PACKAGE_DIR"
f663f264 1437 git $OPTIONS $TAG || exit
cd445739
AM
1438}
1439
1440
3009b80d
ER
1441# this function should exit early if package can't be built for this arch
1442# this avoids unneccessary BR filling.
1443check_buildarch() {
1444 local out ret
13c3c336 1445 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1446 ret=$?
1447 if [ $ret -ne 0 ]; then
1448 echo >&2 "$out"
1449 exit $ret
1450 fi
1451}
1452
9d99a240
ER
1453# from relup.sh
1454set_release() {
1455 local specfile="$1"
1456 local rel="$2"
1457 local newrel="$3"
1458 sed -i -e "
1459 s/^\(%define[ \t]\+_\?rel[ \t]\+\)$rel\$/\1$newrel/
1460 s/^\(Release:[ \t]\+\)$rel\$/\1$newrel/
1461 " $specfile
1462}
1463
1464set_version() {
1465 local specfile="$1"
bc8502e6
ER
1466 local ver="$2" subver=$ver
1467 local newver="$3" newsubver=$newver
1468
1469 # try handling subver, everything that's not numeric-dotted in version
1470 if grep -Eq '%define\s+subver' $specfile; then
1471 subver=$(echo "$ver" | sed -re 's,^[0-9.]+,,')
1472 ver=${ver%$subver}
1473 newsubver=$(echo "$newver" | sed -re 's,^[0-9.]+,,')
1474 newver=${newver%$newsubver}
1475 fi
9d99a240
ER
1476 sed -i -e "
1477 s/^\(%define[ \t]\+_\?ver[ \t]\+\)$ver\$/\1$newver/
bc8502e6 1478 s/^\(%define[ \t]\+subver[ \t]\+\)$subver\$/\1$newsubver/
9d99a240
ER
1479 s/^\(Version:[ \t]\+\)$ver\$/\1$newver/
1480 " $specfile
1481}
1482
cacef28c 1483try_upgrade() {
cd445739 1484 if [ -n "$TRY_UPGRADE" ]; then
9d99a240 1485 local TNOTIFY TNEWVER TOLDVER
ce40491a 1486 update_shell_title "build_package: try_upgrade"
9d99a240 1487
cacef28c 1488 cd "$PACKAGE_DIR"
1489
0907f1eb
ER
1490 if [ "$UPGRADE_VERSION" ]; then
1491 TNEWVER=$UPGRADE_VERSION
cd445739 1492 else
0907f1eb
ER
1493 if [ -n "$FLOAT_VERSION" ]; then
1494 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE -n) || exit 1
1495 else
1496 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE) || exit 1
1497 fi
cd445739 1498
b9bef5ce
ER
1499 # pldnotify.awk does not set exit codes, but it has match for ERROR
1500 # in output which means so.
1501 if [[ "$TNOTIFY" = *ERROR* ]]; then
1502 echo >&2 "$TNOTIFY"
1503 exit 1
1504 fi
1505
0907f1eb
ER
1506 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
1507 fi
cd445739
AM
1508
1509 if [ -n "$TNEWVER" ]; then
1510 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
9d99a240 1511 echo "New version found, updating spec file from $TOLDVER to version $TNEWVER"
257af81b
ER
1512 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1513 cp -f $SPECFILE $SPECFILE.bak
1514 fi
cd445739 1515 chmod +w $SPECFILE
cacef28c 1516 set_release $SPECFILE $PACKAGE_RELEASE 1
9d99a240 1517 set_version $SPECFILE $PACKAGE_VERSION $TNEWVER
518ff1fb 1518 parse_spec
6decb793
ER
1519 if [ "$PACKAGE_VERSION" != "$TNEWVER" ]; then
1520 echo >&2 "Upgrading version failed, you need to update spec yourself"
1521 exit 1
1522 fi
cacef28c 1523 return 1
cd445739
AM
1524 fi
1525 fi
cacef28c 1526 return 0
1527}
1528
1529build_package() {
1530 update_shell_title "build_package"
1531 if [ -n "$DEBUG" ]; then
1532 set -x
1533 set -v
1534 fi
1535
9c909460 1536 cd "$PACKAGE_DIR"
2a5f078d 1537
cd445739
AM
1538 case "$COMMAND" in
1539 build )
1540 BUILD_SWITCH="-ba" ;;
1541 build-binary )
1542 BUILD_SWITCH="-bb" ;;
1543 build-source )
1544 BUILD_SWITCH="-bs --nodeps" ;;
1545 build-prep )
1546 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1547 build-build )
1548 BUILD_SWITCH="-bc" ;;
1549 build-install )
1550 BUILD_SWITCH="-bi" ;;
1551 build-list )
1552 BUILD_SWITCH="-bl" ;;
1553
cd445739 1554 esac
c890b916 1555
2e5be021 1556 update_shell_title "build_package: $COMMAND"
cd445739
AM
1557 if [ -n "$LOGFILE" ]; then
1558 LOG=`eval echo $LOGFILE`
1559 if [ -d "$LOG" ]; then
1560 echo "Log file $LOG is a directory."
1561 echo "Parse error in the spec?"
518ff1fb 1562 Exit_error err_build_fail
cd445739
AM
1563 fi
1564 if [ -n "$LASTLOG_FILE" ]; then
1565 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1566 fi
390d081d 1567 RES_FILE=$(tempfile)
397fa865 1568 local specdir=$(insert_gitlog $SPECFILE)
525bf240 1569
8a037031 1570 (time eval PATH=$CLEAN_PATH ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $specdir/$SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739 1571 RETVAL=`cat $RES_FILE`
397fa865 1572 rm -r $RES_FILE $specdir
cd445739
AM
1573 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1574 if [ "$RETVAL" -eq "0" ]; then
1575 mv $LOG $LOGDIROK
1576 else
1577 mv $LOG $LOGDIRFAIL
1578 fi
1579 fi
8ba5cdda 1580 else
397fa865 1581 local specdir=$(insert_gitlog $SPECFILE)
8a037031 1582 eval PATH=$CLEAN_PATH ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $specdir/$SPECFILE
cd445739 1583 RETVAL=$?
397fa865 1584 rm -r $specdir
8ba5cdda 1585 fi
cd445739
AM
1586 if [ "$RETVAL" -ne "0" ]; then
1587 if [ -n "$TRY_UPGRADE" ]; then
cacef28c 1588 echo "\nUpgrade package to new version failed."
257af81b 1589 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
cacef28c 1590 echo "Restoring old spec file."
257af81b
ER
1591 mv -f $SPECFILE.bak $SPECFILE
1592 fi
cacef28c 1593 echo ""
cd445739 1594 fi
518ff1fb 1595 Exit_error err_build_fail
cd445739
AM
1596 fi
1597 unset BUILD_SWITCH
1598}
1599
f6711e2a 1600nourl() {
cd445739
AM
1601 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1602}
1603
f6711e2a 1604install_required_packages() {
cd445739
AM
1605 run_poldek -vi $1
1606 return $?
1607}
1608
f6711e2a 1609find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
fa4bf1df 1610 local SPEC="$1"
fa4bf1df
ER
1611 awk -F"\n" '
1612 /^%changelog/ { exit }
fa4bf1df
ER
1613 /^%bcond_with/{
1614 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
8ff97f39
ER
1615 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1616 gsub(/[ \t]+/, "_", bcond);
fa4bf1df
ER
1617 print bcond
1618 }' $SPEC | LC_ALL=C sort -u
1619}
1620
117d9861 1621process_bcondrc() {
301cbfd4
ER
1622 # expand bconds from ~/.bcondrc
1623 # The file structure is like gentoo's package.use:
1624 # ---
1625 # * -selinux
1626 # samba -mysql -pgsql
47a8df12 1627 # w32codec-installer license_agreement
301cbfd4
ER
1628 # php +mysqli
1629 # ---
15e34b63 1630 if [ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ]); then
117d9861
ER
1631 :
1632 else
1633 return
1634 fi
301cbfd4 1635
117d9861 1636 SN=${SPECFILE%%\.spec}
c8a3e2ac 1637
117d9861
ER
1638 local bcondrc=$HOME/.bcondrc
1639 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1640
117d9861 1641 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1642
117d9861
ER
1643 while read pkg flags; do
1644 # ignore comments
1645 [[ "$pkg" == \#* ]] && continue
1646
1647 # any package or current package?
1648 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1649 for flag in $flags; do
1650 local opt=${flag#[+-]}
1651
1652 # use only flags which are in this package.
1653 if [[ $bcond_avail = *${opt}* ]]; then
1654 if [[ $flag = -* ]]; then
1655 if [[ $BCOND != *--with?${opt}* ]]; then
1656 BCOND="$BCOND --without $opt"
1657 fi
1658 else
1659 if [[ $BCOND != *--without?${opt}* ]]; then
1660 BCOND="$BCOND --with $opt"
301cbfd4
ER
1661 fi
1662 fi
117d9861
ER
1663 fi
1664 done
1665 fi
1666 done < $bcondrc
1667 update_shell_title "parse ~/.bcondrc: DONE!"
1668}
1669
8ff97f39 1670set_bconds_values() {
117d9861
ER
1671 update_shell_title "set bcond values"
1672
1673 AVAIL_BCONDS_WITHOUT=""
1674 AVAIL_BCONDS_WITH=""
8ff97f39 1675
5a28189c 1676 if grep -Eq '^# *_with' ${SPECFILE}; then
8ff97f39
ER
1677 echo >&2 "ERROR: This spec has old style bconds."
1678 exit 1
1679 fi
1680
1681 if ! grep -q '^%bcond' ${SPECFILE}; then
117d9861 1682 return
301cbfd4
ER
1683 fi
1684
117d9861
ER
1685 local bcond_avail=$(find_spec_bcond $SPECFILE)
1686 process_bcondrc "$SPECFILE"
1687
fa4bf1df 1688 update_shell_title "parse bconds"
2a5f078d 1689
8ff97f39
ER
1690 local opt bcond
1691 for opt in $bcond_avail; do
1692 case "$opt" in
1693 without_*)
1694 bcond=${opt#without_}
10d92f71
ER
1695 case "$BCOND" in
1696 *--without?${bcond}*)
8ff97f39 1697 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
10d92f71
ER
1698 ;;
1699 *)
8ff97f39 1700 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
10d92f71
ER
1701 ;;
1702 esac
cd445739 1703 ;;
8ff97f39
ER
1704 with_*)
1705 bcond=${opt#with_}
10d92f71
ER
1706 case "$BCOND" in
1707 *--with?${bcond}*)
8ff97f39 1708 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
10d92f71
ER
1709 ;;
1710 *)
8ff97f39 1711 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
10d92f71
ER
1712 ;;
1713 esac
cd445739 1714 ;;
8ff97f39
ER
1715 *)
1716 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1717 exit 1
1718 ;;
1719 esac
1720 done
cd445739
AM
1721}
1722
f6711e2a 1723run_sub_builder() {
cd445739 1724 package_name="${1}"
af6b168f 1725 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1726 #
1727